



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Fluent Nhibernate之旅（五）--利用AutoMapping进行简单开发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Fluent Nhibernate之旅（五）--利用AutoMapping进行简单开发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 20:24:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://www.fluentnhibernate.org/" rel="external nofollow noreferrer">Fluent Nhibernate</a>（以下简称FN）发展到如今，已经相当成熟了，在<a href="http://nhforge.org/" rel="external nofollow noreferrer">Nhibernate</a>的书中也相应的推荐了使用FN来进行映射配置，之前写的<a href="http://www.cnblogs.com/inday/archive/2009/10/13/Fluent-NHibernate-Navigation.html" rel="external nofollow noreferrer">FN之旅</a>至今还有很多人会来私信我问题，说来惭愧，从FN之旅四至今已经4年多，至今还未更新过此系列，原因有很多，最大的就是懒惰，哈。</p>
<h1>安装</h1>
<p>现在在项目中使用FN很方便，使用Nuget管理就可以了，但我还是建议大家，可以下载<a href="https://github.com/jagregory/fluent-nhibernate/wiki/Getting-started" rel="external nofollow noreferrer">源代码</a>，自己可以详细了解下。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/4871/201404/011619023596909.png" /></p>
<p>当然，您也可以用命令台来进行安装。说个题外话，NuGet真心不错，至少已经做新项目的时候不用到处去整理lib包了，从NuGet进行下载、更新、卸载都很方便，而且还能自搭建自己公司的服务器，不过目前还是有些问题，有时候在下载最新包无法使用的情况下，无法自动降低版本，还得自己去手动控制台下载，非常不便。</p>
<p>在NuGet下载FluentNhibernate后，会自动下载安装Nhibernate及Iesi。</p>
<h1>配置</h1>
<p>准备工作完成，今天我们要说下FN的AutoMapping，之前呢我们都是用了FluentMapping进行手动的Map映射，如果可以的话，请大家还是使用之前的映射方式，因为AutoMapping有很多契约，您需要按照一定的规范编写您的对象。</p>
<p>我们先看下ISessionFactory中的Mapping配置：</p>
<pre class="prettyprint linenums">    private static ISessionFactory CreateSessionFactory()<br />
        {<br />
            return Fluently.Configure()<br />
               .Database(MsSqlConfiguration.MsSql2005<br />
                    .ConnectionString(s =&gt; s.Server(&quot;.&quot;)<br />
                        .Database(&quot;MyNHibernate&quot;)<br />
                        .TrustedConnection()))<br />
                .Mappings(m =&gt; m.FluentMappings.Add&lt;Store&gt;())<br />
                .BuildSessionFactory();<br />
        }</pre>
<p>这是我们手动映射，Mapping()中指定了用FluentMappings进行映射，我们只要把它改成AutoMapping：</p>
<pre class="prettyprint linenums">    private static ISessionFactory CreateSessionFactory()<br />
        {<br />
            return Fluently.Configure()<br />
               .Database(MsSqlConfiguration.MsSql2005<br />
                    .ConnectionString(s =&gt; s.Server(&quot;.&quot;)<br />
                        .Database(&quot;MyNHibernate&quot;)<br />
                        .TrustedConnection()))<br />
                .Mappings(m =&gt; m.AutoMappings.Add(AutoMap.AssemblyOf&lt;Store&gt;()))<br />
                .BuildSessionFactory();<br />
        }</pre>
<p>红色字体为不同之处，Store是我们需要映射的实体类，可能您会用为何不能像FluentMapping一样Add&lt;T&gt;()呢？因为这里考虑到一些契约的问题，它的Add参数为AutoPersistenceModel类型，接下来会说的。</p>
<h1>数据库结构</h1>
<p>接下来，我们设计一个数据库结构，简单点：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/4871/201404/011619033908195.png" /></p>
<p>员工，仓库，产品，对应关系也全部到位了</p>
<h1>实体类代码</h1>
<p>我们来编写对应的Model代码：</p>
<pre class="prettyprint linenums">public class Store<br />
    {<br />
        public Store()<br />
        {<br />
            Products = new List&lt;Product&gt;();<br />
        }

        public virtual int Id { get; set; }

        public virtual string Name { get; set; }

        public virtual IEnumerable&lt;Product&gt; Products { get; set; }<br />
    }

    public class UserName<br />
    {<br />
        public string FirstName { get; set; }

        public virtual string LastName { get; set; }<br />
    }

    public class Employee<br />
    {<br />
        public virtual int Id { get; set; }

        public virtual UserName Name { get; set; }

        public virtual Store Store { get; set; }<br />
    }

    public class Product<br />
    {<br />
        public Product()<br />
        {<br />
            Stores = new List&lt;Store&gt;();<br />
        }

        public virtual int Id { get; set; }

        public virtual float Price { get; set; }

        public virtual string Name { get; set; }

        public virtual IEnumerable&lt;Store&gt; Stores { get; set; }<br />
    }</pre>
<p>好了，代码编写完毕，接下来是映射吗？？？No，无需映射了，因为我们用了AutoMapping，一切交给FN吧，我们接下来只要编写测试代码即可。</p>
<h1>测试</h1>
<p>我们先配置ISessionFactory：</p>
<pre class="prettyprint linenums">     private static string dbfile = ConfigurationManager.AppSettings[&quot;dbfile&quot;];<br />
        private static ISessionFactory CreateSessionFactory()<br />
        {<br />
            return Fluently.Configure()<br />
                .Database(SQLiteConfiguration.Standard.UsingFile(dbfile))<br />
                .Mappings(m =&gt; m.AutoMappings.Add(AutoMap.AssemblyOf&lt;Store&gt;()))<br />
                .ExposeConfiguration(BuildSchema) //利用Nhibernate的SchemaExport创建数据库及其架构<br />
                .BuildSessionFactory();<br />
        }

        private static void BuildSchema(NHibernate.Cfg.Configuration obj)<br />
        {<br />
            //delete the existing db on each run<br />
            if (File.Exists(dbfile))<br />
                File.Delete(dbfile);

            new SchemaExport(obj).Create(false, true);<br />
        }</pre>
<p>在这里，我用了Sqlite做为我们的数据库，ORM最大的好处就是我们可以随意的变更我们的数据库类型，不需要考虑其类型，这是我选择Nhibernate的原因，EF虽然通过扩展能够支持其他数据库，但我相信用EF使用其他数据库的人很少吧。用ExposeConfiguration方法委托Nhibernate的SchemaExport来创建数据库架构，相信很多NH玩家都会用吧。不过不建议把它用在稍大的项目里，我们的项目数据库会随着项目需求的增加和改变会经常修改的，建议用专业的数据库管理，比如Migrator，有兴趣下次可以开篇介绍下，用下来还是不错的。</p>
<pre class="prettyprint linenums">[Fact]<br />
        public void DemoTest()<br />
        {<br />
            using (var session = CreateSessionFactory().OpenSession())<br />
            {<br />
                new PersistenceSpecification&lt;Employee&gt;(session)<br />
                    .CheckProperty(c =&gt; c.Id, 1)<br />
                    .CheckProperty(c =&gt; c.Name.FirstName, &quot;James&quot;)<br />
                    .CheckProperty(c =&gt; c.Name.LastName, &quot;YinG&quot;)<br />
                    .CheckReference(c =&gt; c.Store, new Store() { Name = &quot;MyStore&quot; })<br />
                    .VerifyTheMappings();<br />
            }<br />
        }</pre>
<p>我们利用XUnit进行测试下，您会发现报错：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/4871/201404/011619049682680.png" /></p>
<p>这是为什么呢？这个其实就是AutoMapping在处理映射的时候，都是按照一定的规则去映射的，细心的朋友可能发现，我们的索引字段的字段名都是Id，这就是AutoMapping的约定，我们也可以自己来进行配置。</p>
<p>刚我们的测试报错，是因为Employee中的Name是个UserName类，Nhibernate的Component，我在<a href="http://www.cnblogs.com/inday/archive/2009/09/08/Fluent-NHibernate-one-to-one.html" rel="external nofollow noreferrer">FN之旅四（上）</a>中有介绍到，默认情况下映射根据字段映射到数据库的，所以上面的测试会报错，接下来我们自己配置下：</p>
<p>编写一个类，继承DefaultAutomappingConfiguration：</p>
<pre class="prettyprint linenums">public class CustomConfiguration : DefaultAutomappingConfiguration<br />
    {<br />
        public override bool IsComponent(Type type)<br />
        {<br />
            return type == typeof(UserName);<br />
        }<br />
    }</pre>
<p>重写IsComponent方法，简单吧，核对下类型即可，写完自己的规则后，我们需要在建立SessionFactory的时候引入此配置：</p>
<pre class="prettyprint linenums">.Mappings(m =&gt; m.AutoMappings.Add(AutoMap.AssemblyOf&lt;Store&gt;(new CustomConfiguration())))</pre>
<p>现在您还无法测试通过，因为我用了PersistenceSpecification进行测试的，在进行常规的测试时是没有问题的，但遇到Component或者Reference之类的，都需要我们自己来写一个IEqualityComparer的实现：</p>
<pre class="prettyprint linenums">public class UserNameComparer : IEqualityComparer<br />
    {<br />
        public new bool Equals(object x, object y)<br />
        {<br />
            var username_x = x as UserName;<br />
            if (username_x == null) return false;<br />
            var username_y = y as UserName;<br />
            if (username_y == null) return false;

            return username_x.FirstName.Equals(username_y.FirstName) &amp;&amp;<br />
                username_x.LastName.Equals(username_y.LastName);<br />
        }

        public int GetHashCode(object obj)<br />
        {<br />
            throw new NotImplementedException();<br />
        }<br />
    }

    public class StoreComparer : IEqualityComparer<br />
    {<br />
        public new bool Equals(object x, object y)<br />
        {<br />
            var Store_x = x as Store;<br />
            if (Store_x == null) return false;<br />
            var Store_y = y as Store;<br />
            if (Store_y == null) return false;

            return Store_x.Id == Store_y.Id;<br />
        }

        public int GetHashCode(object obj)<br />
        {<br />
            throw new NotImplementedException();<br />
        }<br />
    }</pre>
<p>好，修改下我们的测试代码：</p>
<pre class="prettyprint linenums">[Fact]<br />
        public void DemoTest()<br />
        {<br />
            using (var session = CreateSessionFactory().OpenSession())<br />
            {<br />
                new PersistenceSpecification&lt;Employee&gt;(session)<br />
                     .CheckProperty(c =&gt; c.Id, 1)<br />
                     .CheckProperty(c =&gt; c.UserName, new UserName{<br />
                         FirstName = &quot;James&quot;, LastName = &quot;YinG&quot;<br />
                     }, new UserNameComparer())<br />
                     .CheckReference(c =&gt; c.Store, new Store() { Name = &quot;MyStore&quot; }, new StoreComparer())<br />
                     .VerifyTheMappings();<br />
            }<br />
        }</pre>
<p>在进行下测试，这下我们通过了：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/4871/201404/011619056873592.png" /></p>
<p>这里我只测试了Employee和Store两个实体，对于多对多还未测试，时间有限，等有时间下篇继续下。今天介绍了AutoMapping简单的介绍，但在使用中您要时刻注意，AutoMapping是有很多限制的，比如Id，比如Component等，当然我们可以通过重写DefaultAutomappingConfiguration的一些方法来进行合适的一些配置，如果您要对持久类有一些要求，不对一对多的LazyLoad或者Cascade之类的，您需要通过实现IReferenceConvention，IHasManyConvention，IHasManyToManyConvention进行配置，今天就不多讲了，下次吧。</p>
<p>Fluent Nhibernate确实是个好东西，让我在开发上省去了很多时间，今天虽然介绍了AutoMapping，但我不推荐您在您的项目中使用，用起来没手感（个人感觉），需要约定的东西太多了，对于数据库结构也得按照他的契约来，否则就得自己重写一些方法，实现一些类，有点累人。但在开发一些小工具时，又要用到小型存储数据的话，不妨可以试试这种方式。</p>
<p>PS：今天本来心情不错，没想到有客人来拉横幅，一直在公司吵闹，害的我无法集中精力，估计在文章中会有错的地方，大家见谅了。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn61vk9.html">IOS管理文件和目录NSFileManager</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4pld9.html">&lbrack;电脑常见问题&rsqb; win8 ie浏览器打不开</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gwede8.html">Spring-MVC接收request参数和向页面传值总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xr14e8.html">java单元测试&lpar;Junit&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y4l43q.html">h-index</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zx0g49.html">EasyUI 1&period;3之前DataGrid中动态选中、获取Checkbox</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnjnl9.html">ebs清除并法管理器所清除的表</a>
		</li>
						<li><a href="https://www.batexi.com/a/950rpve8.html">js去除首尾空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmgdl8.html">js 设置url 参数值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkz4nz8.html">Android 开发笔记&lowbar;&lowbar;&lowbar;shape</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1oevmq.html">iOS学习&mdash;&mdash;UIAlertController详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5rp09.html">&lbrack;ABP&rsqb;浅谈工作单元 在整个 ABP 框架当中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k6k309.html">Django项目导入Eclipse运行调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdd628.html">checkbox的使用总结&comma;判断是否选中</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25mvjlq.html">腾讯云cos封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/960v2149.html">JVM总结-垃圾回收（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppwz3d9.html">the-implementation-of-epoll</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p312jq.html">软件工程-东北师大站-第八次作业（PSP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koe0g5q.html">一个hql语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4env5q.html">UI设计师必备</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4pzdnq.html">探讨webapp的SEO难题（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdjwrjq.html">iOS 封装添加按钮的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4pjx0q.html">O365（世纪互联）SharePoint 之站点个性化</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyvvjmq.html">Android开发学习&mdash;&mdash;android存储</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9637pn9.html">java设计模式 模板方法模式Template Method</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyvrggq.html">AtomicInteger源码注释</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqverd19.html">ORA-12516：TNS&colon;listener could not find available handler with matching protocol stack</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o4g5lq.html">Linux查看系统开机时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gpg779.html">大数据系列（2）&mdash;&mdash;Hadoop集群坏境CentOS安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mjymr8.html">FastReport自定义数据源及ListView控件的使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
